var nFindAPITries = 0;
var API = null;
var maxTries = 500;
var APIVersion = "";

var interaccionsSCORM = {} // Hash per recuperar, mitjançants ID, l'enter de l'interacció

// The ScanForAPI() function searches for an object named API_1484_11
// in the window that is passed into the function. If the object is
// found a reference to the object is returned to the calling function.
// If the instance is found the SCO now has a handle to the LMS
// provided API Instance. The function searches a maximum number
// of parents of the current window. If no object is found the
// function returns a null reference. This function also reassigns a
// value to the win parameter passed in, based on the number of
// parents. At the end of the function call, the win variable will be
// set to the upper most parent in the chain of parents.
function ScanForAPI(win) {
	while ((win.API_1484_11 == null) && (win.parent != null)
	&& (win.parent != win))
	{
		nFindAPITries++;
		if (nFindAPITries > maxTries)
		{
		return null;
		}
		win = win.parent;
	}
	return win.API_1484_11;
}
// The GetAPI() function begins the process of searching for the LMS
// provided API Instance. The function takes in a parameter that
// represents the current window. The function is built to search in a
// specific order and stop when the LMS provided API Instance is found.
// The function begins by searching the current window’s parent, if the
// current window has a parent. If the API Instance is not found, the
// function then checks to see if there are any opener windows. If
// the window has an opener, the function begins to look for the
// API Instance in the opener window.
function GetAPI(win) {
	if ((win.parent != null) && (win.parent != win)) {
		API = ScanForAPI(win.parent);
	}
	if ((API == null) && (win.opener != null)) {
		API = ScanForAPI(win.opener);
	} 
	if (API != null) {
		APIVersion = API.version;
	}
}


function APIOK() {
	return ((typeof(API)!= "undefined") && (API != null))
}

function DummyAPI() {
    if (APIOK()) return true
    
    API = {
        Initialize: function () {
            return true
        }, GetLastError: function () {
            return true
        }, Commit: function () {
            return true
        }, cmi: {
            interactions: []
        }
    }
    
    
    API.LastError = '0';
    
    API.GetLastError = function() {
        return LastError
    }
    
    API.Terminate = function() {
        return true
    }
    
    
    API.GetValue = function(nam) {
        if (nam == 'cmi.interactions._count') {
            return API.cmi.interactions.length;
        }

        var arguments = nam.split('.');
        var argumentConjunt = [];
        var dada = API;
        for (i = 0; i < arguments.length; i++) {
            try {
                if (i == (arguments.length -1)) return dada[arguments[i]];
                dada = dada[arguments[i]]
            } catch (err) {
                API.LastError = '301 - Get Value'
                return -1
            }
            
        }
        return false    
    }
    
    
    
    API.SetValue = function(nam, val) {

        var arguments = nam.split('.');
        
        var cercaClauEnAPI = function (obj, contador, parametres, valor) {
            if (contador == (parametres.length -1)) {
                    obj[parametres[contador]] = valor;
                    return true;
            }
            
            for (j in obj) {
                if (j == parametres[contador] && contador != (parametres.length -1)) {
                    
                    if (!isNaN(parametres[contador + 1])) {
                        
                        if (obj[j][parametres[contador + 1]] == null || obj[j][parametres[contador + 1]] == 'undefined') {
                            
                            obj[j][parametres[contador + 1]] = new Object;
                        }
                        
                        var nouContador = contador + 2;
                        
                        return cercaClauEnAPI(obj[j][parametres[contador + 1]], nouContador, parametres, valor)
                    
                    } else {
                        var nouContador = contador + 1;
                        return cercaClauEnAPI(obj[j], nouContador, parametres, valor);
                    }
                }    
            }
        }
    return cercaClauEnAPI(API, 0, arguments, val);
    }
}


function LMSInitialize(param) {
	GetAPI(window);
	if (!APIOK()) {
		if (!comprovar_versio_estatica()) {
			alert("No se encontró API de SCORM");
		}
	} else {
		var ret = API.Initialize('');
		if (ret == "false")
		{
			alert("Se ha perdido la conexión con el servidor y no puede guardarse su avance. Por favor, cierre el curso y vuelva a abrirlo. El curso se abrirá por la úma pána que haya quedado registrada correctamente en su seguimiento. El error de salida ha sido:" + LMSGetLastError() + "");
		}
		
		for (i = 0; i < LMSGetValue('cmi.interactions._count'); i++) {	//Reconstrueix el diccionari d'IDs-Enters de registre
			var identificador = LMSGetValue('cmi.interactions.' + i + '.id')
			if (!identificador) {
				return false
			} else {
				interaccionsSCORM[identificador] = i;
			}
		}
	}
}

function comprovar_versio_estatica() {
	if (window.parent.versio_estatica != 'undefined') {
		return window.parent.versio_estatica;
	} 
		return false;
}

function LMSFinish(parm) {
	var ret = API.Terminate('');
	if (ret == "false") {
		alert("Se ha perdido la conexión con el servidor y no puede guardarse su avance. Por favor, cierre el curso y vuelva a abrirlo. El curso se abrirá por la úma pána que haya quedado registrada correctamente en su seguimiento. El error de salida ha sido:" + LMSGetLastError() + "");
	}
}

// Call these functions rather than trying to call the API adapter directly
function LMSSetValue(nam,v)
{
	if (APIOK())
	{
		return API.SetValue(nam,v)
	}
}

function LMSGetValue(nam)
{
	if (APIOK())
	{
		return API.GetValue(nam)
	}
}

function LMSCommit(param)
{
	if (APIOK())
	{
		return API.Commit(param)
	}
}

function LMSGetLastError()
{
	if (APIOK())
	{
		return API.GetLastError()
	}
}

function LMSGetErrorString(n)
{
	if (APIOK())
	{
		return API.GetErrorString(n)
	}
}

function LMSGetDiagnostic(p)
{
	if (APIOK())
	{
		return API.GetDiagnostic(p)
	}
}

// Afegides sota demanda d'Agrega
function ScormInteractionAddRecord(identificador, tipus) {
	if (APIOK()) {
				
		var quantitatInteraccions = LMSGetValue('cmi.interactions._count');
		if (quantitatInteraccions == 256) return -1;
	
		if (interaccionsSCORM[identificador] == null || interaccionsSCORM[identificador] == 'undefined') {
			
			if (LMSSetValue('cmi.interactions.' + quantitatInteraccions + '.id', identificador) &&
				LMSSetValue('cmi.interactions.' + quantitatInteraccions + '.type', tipus)) {
				
				interaccionsSCORM[identificador] = quantitatInteraccions;
				return interaccionsSCORM[identificador];
			} 
		
			return -1	
			
		} else if (LMSGetValue('cmi.interactions.' + interaccionsSCORM[identificador] + '.type') != tipus) {
			return -1
		};	
	 }
}

function ScormInteractionGetIndex(identificador) {
	if (interaccionsSCORM[identificador] == null || interaccionsSCORM[identificador] == 'undefined') return -1;
	return interaccionsSCORM[identificador]
}

function ScormInteractionGetData(identificador, dada) {
	if (interaccionsSCORM[identificador] == null || interaccionsSCORM[identificador] == 'undefined') return false;
	return LMSGetValue('cmi.interactions.' + interaccionsSCORM[identificador] + '.' + dada + '')
}

function ScormInteractionSetData(identificador, dada, valor) {
	if (interaccionsSCORM[identificador] == null || interaccionsSCORM[identificador] == 'undefined') return false;
	return LMSSetValue('cmi.interactions.' + interaccionsSCORM[identificador] + '.' + dada + '', valor)
}

function ScormInteractionGetCount() {
	return LMSGetValue('cmi.interactions._count')
}

// Fi de les funcions pròpies d'Agrega

function alerta_estado()
{
	var estado = LMSGetValue("cmi.core.lesson_status");
	debugme("Estado de la Lesson: " + estado);
}
	
function LMS_Terminate()
{
	LMSFinish("");
	debugme("Desconectado");

}

//Iniciar sesion, cambiar lesson_status solamente si es not attempted,
//iniciar el timer y por ultimo, leer suspend_data

function iniciar_LMS()
{
	LMSInitialize("");
	var estado_leccion = LMSGetValue("cmi.completion_status");
	if (estado_leccion == "not_attempted" || estado_leccion == "unknown")
	{
		LMSSetValue("cmi.completion_status", "incomplete");
	} else {
		debugme("El estado no ha sido alterado y es: " + LMSGetValue("cmi.completion_status"));
	}

    LMSSetValue("cmi.score.min", "0");
    LMSSetValue("cmi.score.max", "100");
        
            

	// obtenemos los datos de suspend_data, que son los modulos y apartados
	// completados, que se guardan en los arrays 'modulos' y 'apartados'
	//obtenir_meta();

	// comenzamos a contar el tiempo
	startTimer();
}


function terminar_LMS() {
//	alert('anem a acabar sessio');
	var stat;
	if (APIOK())
	{
		// obtenim el temps
		sumar_tiempo();
		//guardar_meta();
        var estado_leccion = LMSGetValue("cmi.core.lesson_status");
    
        LMSSetValue('cmi.exit', 'suspend');
                
        var completats = 0;
            
        for (i = 0; i < ScormInteractionGetCount(); i++) {
            var completat = (LMSGetValue('cmi.interactions.' + i + '.result') || 'Cap intent enregistrat')
            
            if (completat == 'correct') {
                completats++
            }
        }    
            
        var puntuacioBruta = Math.floor(1000* (completats / ScormInteractionGetCount()))/100
        var puntuacioScaled = String(Math.floor(1000* (completats / ScormInteractionGetCount()))/1000)
            
        LMSSetValue('cmi.score.raw', String(puntuacioBruta));
        LMSSetValue('cmi.score.scaled', puntuacioScaled);
            
        if (puntuacioBruta > 80) {
            LMSGetValue('cmi.core.lesson_status','completed')
        }
        
		stat = LMSCommit('');
		if (stat == "false")
		{
			//alert("No puedo hacer Commit. Error fue: " + LMSGetLastError() + "; " + LMSGetErrorString());
		} else {
			debugme("El tiempo total es " + LMSGetValue('cmi.core.total_time'));
			LMSFinish("");
			return true;
		}
	}
	return false;
}

function completar_sco()
{
	var estado_leccion = LMSGetValue("cmi.core.lesson_status");
	if (estado_leccion != "completed")
	{
		debugme('modificamos lesson_status de ' + estado_leccion + ' a completed');
		LMSSetValue('cmi.core.lesson_status', 'completed');
	} else {
		debugme('lesson_status ya estaba completed, no lo modificamos');
	}
}
var debug = false;
//Funciones de reloj//
function debugme(missatge)
{
	if (debug) {
	alert(missatge);
	}

}

function startTimer()
{
	startDate = new Date().getTime();
	debugme(startDate);
}

function computeTime()
{
	var formattedTime = "00:00:00.0";
	if ( startDate != 0 )
	{
      	var currentDate = new Date().getTime();
		var elapsedCentiSeconds = ( (currentDate - startDate) / 10 );
      	formattedTime = centisecsToISODuration(elapsedCentiSeconds)
	}
	return formattedTime;		
} 

function convertTotalSeconds(ts)
{	
	var Sec = (ts % 60);
	ts -= Sec;
	var tmp = (ts % 3600);  //# of seconds in the total # of minutes
	ts -= tmp;              //# of seconds in the total # of hours
	if ( (ts % 3600) != 0 ) var Hour = "00" ;
	else var Hour = ""+ (ts / 3600);
	if ( (tmp % 60) != 0 ) var Min = "00";
	else var Min = ""+(tmp / 60);
	Sec=""+Sec
	Sec=Sec.substring(0,Sec.indexOf("."))
	if (Hour.length < 2)Hour = "0"+Hour;
	if (Min.length < 2)Min = "0"+Min;
	if (Sec.length <2)Sec = "0"+Sec;
	var rtnVal = Hour+":"+Min+":"+Sec;
	return rtnVal;
}
	
function sumar_tiempo()
{
	var myTime = computeTime();
	LMSSetValue("cmi.session_time", myTime);
	debugme('el tiempo de la sesion actual es ' + myTime);

}


